# Bluetooth Developer Studio

## Example Plugin - Android Profile Validator

### Author: 
Martin Woolley, Bluetooth SIG 

Twitter: @bluetooth_mdw

__Description:__ 
This plugin generates code for an Android application which can be used to validate a server-based implementation of the selected profile. Validation entails checking that a selected device has no more and no less than the services, characteristics and descriptors defined in the profile and that each characteristic has the specified properties. 

__A Note About Namespace and Android Packages__

When you create your Bluetooth Developer Studio project, you will need to supply a namespace value, typically in the form com.your_company.application e.g. 

    com.example.hrm

Continuing with this example, the Android Studio project for which code is generated by the plugin will use the Java package name:

    com.example.hrm.profile_validator
 
and you should specify an application name of "profile_validator" and a company domain of hrm.example.com to the Android Studio new project wizard. 

__Instructions:__<br>
1. Install Android Studio <br>
2. Run the plugin from within Bluetooth Developer Studio<br>
3. Create a new project in Android Studio. Code generated by Bluetooth Developer Studio will be copied into this project next. Provide the namespace you specified to Bluetooth Developer Studio as the domain and use 'profile_validator' as the application name.
4. Go to the output directory which you selected when generating your code and run the generated batch file copy_to_android_studio.bat with the path to your Android Studio project directory as an argument. e.g.<br> 
copy_to_android_studio.bat C:\workspaces\AndroidstudioProjects\profile_validator<br> 
7. Open the Android Studio project if not already open. Build and install on an Android device for testing.
 
__Code Completion:__ To finish, you will probably want to add some filtering to the scanning process so that only relevant devices are shown on the initial scanning screen.

__Status:__ Example

__Known Issues:__

1. This plugin has had minimal testing.
2. Code is created for Android 5. Android 6 devices may require changes manually applying concerning permissions. See https://developer.android.com/training/permissions/requesting.html
